package com.ruoyi.platform.mapper;


import com.ruoyi.platform.domain.Dataset;
import com.ruoyi.platform.domain.Models;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;
import java.util.List;
import java.util.Map;

/**
 * (Models)表数据库访问层
 *
 * @author Xidaray
 * @since 2023-11-28 16:26:00
 */
public interface ModelsDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    Models queryById(Integer id);

    Models findByName(@Param("name") String name);

    /**
     * 查询指定行数据
     *
     * @param models 查询条件
     * @param pageable         分页对象
     * @return 对象列表
     */
    List<Models> queryAllByLimit(@Param("models") Models models, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param models 查询条件
     * @return 总行数
     */
    long count(@Param("models") Models models);

    /**
     * 新增数据
     *
     * @param models 实例对象
     * @return 影响行数
     */
    int insert(@Param("models") Models models);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<Models> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<Models> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<Models> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<Models> entities);

    /**
     * 修改数据
     *
     * @param models 实例对象
     * @return 影响行数
     */
    int update(@Param("models") Models models);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

}

